talon540website/inventory/urls.py
from django.urls import path

from . import views
from inventory.views import BrowseView, LocationDetailView, ItemDetailView, ItemCreate, LocationCreate, ItemDeleteView, LocationDeleteView, ItemUpdateView, LocationUpdateView, AddOrTakeView

app_name = 'inventory'
urlpatterns = [
    path('', BrowseView.as_view(), name='browse'),
    path('item-create', ItemCreate.as_view(), name='item_create'),
    path('location-create', LocationCreate.as_view(), name='location_create'),
    path('I<int:pk>/', ItemDetailView.as_view(), name='item_detail'),
    path('L<int:pk>/', LocationDetailView.as_view(), name='location_detail'),
    path('I<int:pk>/update/', ItemUpdateView.as_view(), name='item_update'),
    path('L<int:pk>/update/', LocationUpdateView.as_view(), name='location_update'),
    path('I<int:pk>/addortake/', AddOrTakeView.as_view(), name='add_or_take'),
    path('I<int:pk>/delete/', ItemDeleteView.as_view(), name='item_delete'),
    path('L<int:pk>/delete/', LocationDeleteView.as_view(), name='location_delete'),
    #path('upload/', views.upload, name='upload'),
    #path('<str:barcode>/submit/', views.addOrTake, name='addOrTake'),
    #path('<str:barcode>/edit/', views.edit, name='edit'),
    #path('<str:barcode>/edit/submit/', views.editSubmit, name='editSubmit'),
]

talon540website/main/urls.py
from django.urls import path

from . import views

app_name = 'main'
urlpatterns = [
    path('', views.home, name='home'), 
]

talon540website/talon540/urls.py
from django.contrib import admin
from django.urls import include, path
from django.contrib.auth import views as auth_views
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include('main.urls')),
    path('inventory/', include('inventory.urls')),
    path('accounts/', include('login.urls')),
    path('scouting/', include('scouting.urls')),
    path('admin/', admin.site.urls),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

talon540website/inventory/models.py
from django.db import models
from django.conf import settings
from django.db.models.signals import pre_save, pre_delete, post_delete
from django.dispatch import receiver
from django.urls import reverse
from shutil import copyfile
import shortuuid
import os

# Generate barcode for items and locations
def generate_barcode():
    return shortuuid.uuid()

class Entry(models.Model):
    name = models.CharField(max_length=100, unique=True)
    description = models.TextField(blank=True)
    image = models.ImageField(blank=True, upload_to='inventory_images/')
    barcode = models.CharField(max_length=30, default=generate_barcode) #TODO: change max length to desired length depending on barcode system
    
    class Meta:
        abstract = True

    def __str__(self):
        return self.name

    @property
    def image_url(self):
        if self.image:
            return self.image.url
        else:
            return '/static/inventory/images/default.png'

class Item(Entry):
    unit = models.CharField(max_length=20)
    quantity = models.PositiveIntegerField(default=0)
    vendor = models.CharField(default='None', max_length=50)
    part_number = models.CharField(default='None', max_length=50)
    report_count = models.IntegerField(default=0)

    def get_absolute_url(self):
        return reverse('inventory:item_detail', kwargs={'pk': self.pk})

class Location(Entry):
    items = models.ManyToManyField(Item, through='Stored')

    def get_absolute_url(self):
        return reverse('inventory:location_detail', kwargs={'pk': self.pk})

class Stored(models.Model):
    location = models.ForeignKey(Location, on_delete=models.SET_NULL, null=True)
    item = models.ForeignKey(Item, on_delete=models.SET_NULL, null=True, blank=True)
    location_quantity = models.IntegerField()
    
    def __str__(self):
        return str(self.item) + ", " + str(self.location)

@receiver(pre_save, sender=Item)
@receiver(pre_save, sender=Location)
def audoDeleteFileOnChange(sender, instance, **kwargs):
    if not instance.pk:
        return False

    try:
        old_image = sender.objects.get(pk=instance.pk).image
        new_image = instance.image
    except sender.DoesNotExist:
        return False

    if old_image:
        if not old_image == new_image:
            if os.path.isfile(old_image.path):
                os.remove(old_image.path)

@receiver(pre_delete, sender=Location)
def autoChangeQuantityOnDelete(sender, instance, **kwargs):
    for item in instance.items.all():
        stored = Stored.objects.get(item=item, location=instance)
        item.quantity -= stored.location_quantity
        item.save()

@receiver(pre_delete, sender=Item)
@receiver(pre_delete, sender=Location)
def autoDeleteStoredOnDelete(sender, instance, **kwargs):
    for stored in instance.stored_set.all():
        stored.delete()
        
@receiver(post_delete, sender=Item)
@receiver(post_delete, sender=Location)
def autoDeleteFileOnDelete(sender, instance, **kwargs):
    if instance.image:
        if os.path.isfile(instance.image.path):
            os.remove(instance.image.path)

talon540website/inventory/forms.py
from django import forms
from django.core.validators import MinValueValidator
from inventory.models import Item, Location

class ItemForm(forms.ModelForm):
    class Meta:
        model = Item
        fields = ['name', 'description', 'unit', 'vendor', 'part_number', 'image']

class LocationForm(forms.ModelForm):
    class Meta:
        model = Location
        fields = ['name', 'description', 'image']

class AddOrTakeForm(forms.Form):
    target = forms.ChoiceField()
    amount = forms.IntegerField(validators=[MinValueValidator(0)])

    def __init__(self, *args, **kwargs):
        locations = kwargs.pop('locations', None)
        super(AddOrTakeForm, self).__init__(*args, **kwargs)
        self.fields['target'] = forms.ChoiceField(choices=locations)

talon540website/inventory/views.py
from django.http import HttpResponseRedirect
from django.urls import reverse, reverse_lazy
from django.views import View
from django.shortcuts import get_object_or_404
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import FormView, CreateView, DeleteView, UpdateView
from .forms import ItemForm, LocationForm, AddOrTakeForm
from .models import Item, Location, Stored

class BrowseView(ListView):
    model = Item
    template_name = 'inventory/browse.html'
    context_object_name = 'items'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['locations'] = Location.objects.all()
        context['item_form'] = ItemForm
        context['location_form'] = LocationForm
        return context

class BaseCreate(CreateView):
    def get(self, request):
        return HttpResponseRedirect(reverse('inventory:browse'))

class ItemCreate(BaseCreate):
    model = Item
    form_class = ItemForm

    def form_valid(self, form): #TODO: clean this up
        self.object = form.save()

        # Variables for all the location and quantities for the item being created, as well as the total quantity of the item
        locs = []
        quants = []
        total = 0
        quantities = True
        i = 1

        while quantities:
            loc = self.request.POST.get('loc' + str(i), 'None').strip()
            quant = self.request.POST.get('quant' + str(i), "None").strip()
            i += 1
            if quant.isdigit():
                quant = int(quant)
                if quant > 0 and loc != 'None':
                    quants.append(quant)
                    total += quant
                    locs.append(loc)
            else:
                quantities = False
                
        # Create relations between item and locations
        i = 0
        for loc in locs:
            try:
                location = Location.objects.get(name=loc)
            except Location.DoesNotExist:
                location = Location(name=loc)
                location.save()
            stored = Stored(item=self.object, location=location, location_quantity=quants[i])
            stored.save()
            i += 1

        self.object.quantity = total
        self.object.save()
        
        return HttpResponseRedirect(self.get_success_url())

class LocationCreate(BaseCreate):
    model = Location
    form_class = LocationForm

class ItemDetailView(DetailView):
    model = Item
    
    def get_context_data(self, **kwargs):
        location_options = Location.objects.values_list('pk', 'name')
        context = super().get_context_data(**kwargs)
        context['edit_form'] = ItemForm
        context['addtake_form'] = AddOrTakeForm(locations=location_options)
        return context

class LocationDetailView(DetailView):
    model = Location
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['edit_form'] = LocationForm
        return context

class AddOrTakeView(View):
    form_class = AddOrTakeForm

    def get(self, request, pk):
        return HttpResponseRedirect(reverse('inventory:item_detail', args=(pk,)))

    def post(self, request, pk):
        location_options = Location.objects.values_list('pk', 'name')
        form = self.form_class(request.POST, locations=location_options)
        if form.is_valid():
            return self.form_valid(form)
        else:
            return self.form_invalid(form)
    
    def form_valid(self, form):
        target = form.cleaned_data['target']
        amount = form.cleaned_data['amount']

        item = get_object_or_404(Item, pk=self.kwargs['pk'])
        location = get_object_or_404(Location, pk=target)
        
        try:
            stored = Stored.objects.get(item=item, location=location)
        except Stored.DoesNotExist:
            if 'take' in form.data:
                return HttpResponseRedirect(reverse('inventory:item_detail', kwargs=self.kwargs))
            stored = Stored(item=item, location=location, location_quantity=0)
            stored.save()
            
        if 'add' in form.data:
            item.quantity += amount
            stored.location_quantity += amount
        elif 'take' in form.data:
            if amount > stored.location_quantity:
                return HttpResponseRedirect(reverse('inventory:item_detail', kwargs=self.kwargs))
            item.quantity -= amount
            stored.location_quantity -= amount

        item.save()
        
        if stored.location_quantity > 0:
            stored.save()
        else:
            stored.delete()

        return HttpResponseRedirect(reverse('inventory:item_detail', kwargs=self.kwargs))

    def form_invalid(self, form):
        return HttpResponseRedirect(reverse('inventory:item_detail', kwargs=self.kwargs))

class BaseUpdateView(UpdateView):
    def get(self, request, pk):
        return HttpResponseRedirect(reverse('inventory:browse'))

class ItemUpdateView(BaseUpdateView):
    model = Item
    form_class = ItemForm
    template_name = 'inventory/item_detail.html'

class LocationUpdateView(BaseUpdateView):
    model = Location
    form_class = LocationForm
    template_name = 'inventory/location_detail.html'

class BaseDeleteView(DeleteView):
    success_url = reverse_lazy('inventory:browse')
    
    def get(self, request, pk):
        return HttpResponseRedirect(reverse('inventory:browse'))

class ItemDeleteView(BaseDeleteView):
    model = Item

class LocationDeleteView(BaseDeleteView):
    model = Location

talon540website/inventory/templates/inventory/browse.html
{% extends 'main/base.html' %} {% load static %}

{% block stylesheets %}
<link rel="stylesheet" href="{% static 'inventory/css/browse.css' %}">
{% endblock %}

{% block js %}
<script type="text/javascript" src="{% static 'inventory/js/inventory-functions.js' %}"></script>
{% endblock %}

{% block nav_home %} class="button" {% endblock %}
{% block nav_scouting %} class="button" {% endblock %}
{% block nav_contact %} class="button-selected" {% endblock %}
{% block nav_sign-in %} class="button" {% endblock %}

{% block content %}
    <div class="page-tlt">
        <h1>Inventory</h1>
        <div class="right-triangle-decoration page-tlt-triangle wss"></div>
    </div>
    
    <div class="button-content">
        <div class="sort-tab">
            <h1 class="button tab-header">Display by:</h1>
            <h1 class="button tabbutton" id="sort-item">Item</h1>
            <h1 class="button tabbutton" id="sort-location">Location</h1>
            <div class="add-tab">
		        <h1 class="button bannerbutton item-trigger" id="btn-addItem">+ New Item</h1>
		        <h1 class="button bannerbutton item-trigger" id="btn-addItem-alt">+ <i class="fas fa-box"></i></h1>
                <h1 class="button bannerbutton loc-trigger" id="btn-addLocation">+ New Location</h1>
                <h1 class="button bannerbutton loc-trigger" id="btn-addLocation-alt">+ <i class="fas fa-map-marker-alt"></i></h1>
                <h1 class="button bannerbutton xcel-trigger" id="btn-addExcel">+ Upload Excel</h1>
                <h1 class="button bannerbutton xcel-trigger" id="btn-addExcel-alt">+ <i class="fas fa-file-excel"></i></h1>
            </div>
            <div class="search-bar">
                <h1><i class="fas fa-search"></i></h1>
                <input id="search-input" type="text" placeholder='Search Inventory'>
            </div>
        </div>
    </div>
    
    <div class="divide-content" id="dc-addItem">
        <form action="{% url 'inventory:item_create' %}" method="POST" enctype="multipart/form-data">{% csrf_token %}
            <h1>ADD AN ITEM</h1>
            <div class="addText-section">
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ item_form.name.id_for_label }}">+ Name</label>
                    </div>
                    {{ item_form.name }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ item_form.description.id_for_label }}">+ Description</label>
                    </div>
                    {{ item_form.description }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ item_form.unit.id_for_label }}">+ Unit</label>
                    </div>
                    {{ item_form.unit }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ item_form.vendor.id_for_label }}">+ Vendor</label>
                    </div>
                    {{ item_form.vendor }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ item_form.part_number.id_for_label }}">+ Part #</label>
                    </div>
                    {{ item_form.part_number }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper label-wrapper-file">
                        <label for="{{ item_form.image.id_for_label }}">+ Image</label>
                    </div>
                    {{ item_form.image }}
                </div>
            </div>
            <div class="addLocation-section" id="al-section">
                <div id="dl-locations-section">
                    <div class="divide-line" id="dl-locations">
                        <h1>Location 1</h1>
                        <select name='loc1' id='loc1' required>
                            {% for location in locations %}
                                <option value="{{ location }}">{{ location }}</option>
                            {% endfor %}
                            <option value="None" selected='selected'>No Location</option>
                        </select>
                        <input type="number" min="0" name='quant1' id='quant1' placeholder="Quantity" required>
                    </div>
                </div>
                <h1 class="wide-button" id="addlocation-btn">+ Location</h1>
            </div>
            <div class="end-button-row">
                <input class="add-button" type="submit" name="item" value="Add new item">
            </div>
        </form>
    </div>
        
    <div class="divide-content" id="dc-addLocation">
        <form action="{% url 'inventory:location_create' %}" method="POST" enctype="multipart/form-data">{% csrf_token %}
            <h1>ADD A LOCATION</h1>
            <div class="addText-section">
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ location_form.name.id_for_label }}">+ Name</label>
                    </div>
                    {{ location_form.name }}
                </div>
                <div class="divide-line minor">
                    <div class="label-wrapper">
                        <label for="{{ location_form.description.id_for_label }}">+ Description</label>
    		        </div>
                    {{ location_form.description }}
    	        </div>
                <div class="divide-line minor">
                    <div class="label-wrapper label-wrapper-file">
                        <label for="{{ location_form.image.id_for_label }}">+ Image</label>
                    </div>
                    {{ location_form.image }}
                </div>
            </div>
            <div class="end-button-row">
                <input class="add-button" type="submit" name="location" value="Add new location">
            </div>
        </form>
    </div>
    
    <div class="divide-content" id="dc-addExcel">     
    	<form action="" method="post" enctype="multipart/form-data">{% csrf_token %}
            <h1>UPLOAD EXCEL</h1>
            <div class="addText-section">
                <div class="divide-line minor">
                    <div class="label-wrapper label-wrapper-file">
                        <label for="excel_file">+ Excel File</label>
                    </div>
                    <input type="file" name="excel_file" id="excel_file">
                </div>
            </div>
            <div class="end-button-row">
                <input class="add-button" type="submit" name="upload" value="Add new item">
            </div>
        </form>
    </div>

    <div class="body-content">
        <div class="item-table">
            <table id="it">
                <thead>
                    <tr class="table-header">
                        <th>Name</th>
                        <th>Unit of Measurement</th>
                        <th>Quantity</th>
                        <th>Barcode</th>
                        <th>Location(s)</th>
                        <th>More Info</th>
                    </tr>
                </thead>
                <tbody>
                    {% for item in items %}
                        <tr>
                            <td>{{ item.name }}</td>
                            <td>{{ item.unit }}</td>
                            <td>{{ item.quantity }}</td>
                            <td>{{ item.barcode }}</td>
                            <td>
                                {{ item.location_set.all|join:", " }}
                            </td>
                            <td>
                                <a href="{% url 'inventory:item_detail' item.pk %}">Details</a>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
            <h1 class="item-table-null null-remove" id="it-n">The Item Inventory is empty. Please add new items!</h1>
            <h1 class="table-noresults null-remove">Your search query yielded no results</h1>
        </div>
        
        <div class="location-table null-table">
            <table id="it">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Barcode</th>
                        <th>Item(s)</th>
                        <th>More Info</th>
                    </tr>
                </thead>
                <tbody>
                    {% for location in locations %}
                        <tr>
                            <td>{{ location.name }}</td>
                            <td>{{ location.barcode }}</td>
                            <td>
                                {% for item in location.items.all %}
                                    {{ item }}, 
                                {% endfor %}
                            </td>
                            <td>
                                <a href="{% url 'inventory:location_detail' location.pk %}">Details</a>
                            </td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
            <h1 class="location-table-null null-remove" id="lt-n">The Location Directory is empty. Please add new Locations!</h1>
            <h1 class="table-noresults null-remove">Your search query yielded no results</h1>
        </div>
    </div>
{% if messages %}
    {% for message in messages %}
        {{ message }}
    {% endfor %}
{% endif %}
{% endblock %}

talon540website/inventory/templates/inventory/edit.html
{% if item %}

{% endif %}

talon540website/inventory/templates/inventory/item_detail.html
<h1>{{ object.name }}</h1>
<p>{{ object.description }}</p>
<p>{{ object.quantity }}</p>
<p>{{ object.barcode }}</p>

<img src="{{ item.image_url }}" alt="heck">

<h1 class="location-tlt">Locations of item</h1>
<div class="scrollable-table">
<table>
    <thead>
        <th>Name</th>
        <th>Barcode</th>
        <th>Quantity</th>
    </thead>
{% for stored in object.stored_set.all %}
    <tr>
       <td>{{ stored.location }}</td>
       <td>{{ stored.location.barcode }}</td>
       <td>{{ stored.location_quantity }}</td>
    </tr>
{% endfor %}
</table>

<form method="post" action="{% url 'inventory:add_or_take' object.pk %}"> {% csrf_token %}
    {{ addtake_form.as_p }}
    <input type="submit" name="add" value="add">
    <input type="submit" name="take" value="take">
</form>

<form method="post" action="{% url 'inventory:item_delete' object.pk %}">{% csrf_token %}
    <input type="submit" value="Confirm">
</form>

<form method="post" action="{% url 'inventory:item_update' object.pk %}" enctype="multipart/form-data">{% csrf_token %}
    {{ edit_form.as_p }}
    <input type="submit" value="Update">
</form>

talon540website/inventory/templates/inventory/location_detail.html
<h1>{{ object.name }}</h1>
<p>{{ object.description }}</p>
<p>{{ object.barcode }}</p>

<h1 class="location-tlt">Locations of item</h1>
<div class="scrollable-table">
<table>
    <thead>
        <th>Name</th>
        <th>Barcode</th>
        <th>Quantity</th>
    </thead>
{% for stored in object.stored_set.all %}
    <tr>
       <td>{{ stored.item }}</td>
       <td>{{ stored.item.barcode }}</td>
       <td>{{ stored.location_quantity }}</td>
    </tr>
{% endfor %}
</table>

<form method="post" action="{% url 'inventory:location_delete' object.pk %}">{% csrf_token %}
    <input type="submit" value="Confirm">
</form>